//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "rtklib.h"
#include "naviopt.h"
#include "viewer.h"
#include "refdlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptDialog *OptDialog;
//---------------------------------------------------------------------------
__fastcall TOptDialog::TOptDialog(TComponent* Owner)
	: TForm(Owner)
{
	AnsiString label,s;
	int freq[]={1,2,5,7,6};
	PrcOpt=prcopt_default;
	SolOpt=solopt_default;
	UpdateEnable();
	PosFont=new TFont;
	
	Freq->Items->Clear();
	for (int i=0;i<NFREQ;i++) {
		label=label+(i>0?"+":"")+s.sprintf("L%d",freq[i]);
		Freq->Items->Add(label);
	}
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::FormShow(TObject *Sender)
{
	GetOpt();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnOkClick(TObject *Sender)
{
	SetOpt();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnLoadClick(TObject *Sender)
{
	OpenDialog->Title="Options File";
	OpenDialog->FilterIndex=0;
	if (!OpenDialog->Execute()) return;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnSaveClick(TObject *Sender)
{
	SaveDialog->Title="Options File";
	SaveDialog->FilterIndex=0;
	if (!SaveDialog->Execute()) return;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnPrecEphViewClick(TObject *Sender)
{
	if (PrecEphFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(PrecEphFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnPrecEphFileClick(TObject *Sender)
{
	OpenDialog->Title="Satellite Precise Ephemeris File";
	OpenDialog->FileName=PrecEphFile->Text;
	OpenDialog->FilterIndex=5;
	if (!OpenDialog->Execute()) return;
	PrecEphFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnStaPosViewClick(TObject *Sender)
{
	if (StaPosFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(StaPosFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnStaPosFileClick(TObject *Sender)
{
	OpenDialog->Title="Station Postion File";
	OpenDialog->FileName=StaPosFile->Text;
	OpenDialog->FilterIndex=1;
	if (!OpenDialog->Execute()) return;
	StaPosFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RovPosTypeChange(TObject *Sender)
{
	TEdit *edit[]={RovPos1,RovPos2,RovPos3};
	double pos[3];
	GetPos(RovPosTypeF,edit,pos);
	SetPos(RovPosType->ItemIndex,edit,pos);
	RovPosTypeF=RovPosType->ItemIndex;
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RefPosTypeChange(TObject *Sender)
{
	TEdit *edit[]={RefPos1,RefPos2,RefPos3};
	double pos[3];
	GetPos(RefPosTypeF,edit,pos);
	SetPos(RefPosType->ItemIndex,edit,pos);
	RefPosTypeF=RefPosType->ItemIndex;
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnRovPosClick(TObject *Sender)
{
	TEdit *edit[]={RovPos1,RovPos2,RovPos3};
	double p[3],pos[3];
	GetPos(RovPosType->ItemIndex,edit,p);
	ecef2pos(p,pos);
	RefDialog->RovPos[0]=pos[0]*R2D;
	RefDialog->RovPos[1]=pos[1]*R2D;
	RefDialog->Pos[2]=pos[2];
	RefDialog->StaPosFile=StaPosFile->Text;
	RefDialog->Left=Left+Width/2-RefDialog->Width/2;
	RefDialog->Top=Top+Height/2-RefDialog->Height/2;
	if (RefDialog->ShowModal()!=mrOk) return;
	pos[0]=RefDialog->Pos[0]*D2R;
	pos[1]=RefDialog->Pos[1]*D2R;
	pos[2]=RefDialog->Pos[2];
	pos2ecef(pos,p);
	SetPos(RovPosType->ItemIndex,edit,p);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnRefPosClick(TObject *Sender)
{
	TEdit *edit[]={RefPos1,RefPos2,RefPos3};
	double p[3],pos[3];
	GetPos(RefPosType->ItemIndex,edit,p);
	ecef2pos(p,pos);
	RefDialog->RovPos[0]=pos[0]*R2D;
	RefDialog->RovPos[1]=pos[1]*R2D;
	RefDialog->RovPos[2]=pos[2];
	RefDialog->StaPosFile=StaPosFile->Text;
	RefDialog->Left=Left+Width/2-RefDialog->Width/2;
	RefDialog->Top=Top+Height/2-RefDialog->Height/2;
	if (RefDialog->ShowModal()!=mrOk) return;
	pos[0]=RefDialog->Pos[0]*D2R;
	pos[1]=RefDialog->Pos[1]*D2R;
	pos[2]=RefDialog->Pos[2];
	pos2ecef(pos,p);
	SetPos(RefPosType->ItemIndex,edit,p);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnAntPcvViewClick(TObject *Sender)
{
	if (AntPcvFile->Text=="") return;
	TTextViewer *viewer=new TTextViewer(Application);
	viewer->Show();
	viewer->Read(AntPcvFile->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnAntPcvFileClick(TObject *Sender)
{
	OpenDialog->Title="Antenna PCV File";
	OpenDialog->FileName=AntPcvFile->Text;
	OpenDialog->FilterIndex=3;
	if (!OpenDialog->Execute()) return;
	AntPcvFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnGoogleEarthFileClick(TObject *Sender)
{
	OpenDialog->Title="Google Earth Exe File";
	OpenDialog->FileName=GoogleEarthFile->Text;
	OpenDialog->FilterIndex=2;
	if (!OpenDialog->Execute()) return;
	GoogleEarthFile->Text=OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::BtnFontClick(TObject *Sender)
{
	AnsiString s;
	FontDialog->Font=FontLabel->Font;
	if (!FontDialog->Execute()) return;
	FontLabel->Font=FontDialog->Font;
	FontLabel->Caption=FontLabel->Font->Name+s.sprintf(" %dpt",FontLabel->Font->Size);
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::FreqChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SolFormatChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::PosModeChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::AmbResChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RovAntPcvClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SatClkCorrClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::IntpRefObsClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RovPosClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::RefPosClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::OutputHeightClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::NmeaReqCClick(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::DgpsCorrLChange(TObject *Sender)
{
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::GetOpt(void)
{
	TEdit *editu[]={RovPos1,RovPos2,RovPos3};
	TEdit *editr[]={RefPos1,RefPos2,RefPos3};
	AnsiString s;
	
	PosMode		 ->ItemIndex=PrcOpt.mode;
	Freq		 ->ItemIndex=PrcOpt.nf-1>NFREQ-1?NFREQ-1:PrcOpt.nf-1;
	ElMask		 ->Text     =s.sprintf("%.0f",PrcOpt.elmin*R2D);
	SnrMask		 ->Text     =s.sprintf("%.0f",PrcOpt.snrmin);
	IonoEst		 ->ItemIndex=PrcOpt.estiono;
	TropEst		 ->ItemIndex=PrcOpt.esttrop;
	AmbRes		 ->ItemIndex=PrcOpt.modear;
	ValidThresAR ->Text     =s.sprintf("%.1f",PrcOpt.thresar);
	OutCntResetBias->Text   =s.sprintf("%d",  PrcOpt.maxout);
	LockCntFixAmb  ->Text   =s.sprintf("%d",  PrcOpt.minlock);
	ElMaskAR	 ->Text     =s.sprintf("%.0f",PrcOpt.elmaskar*R2D);
	MaxAgeDiff	 ->Text     =s.sprintf("%.1f",PrcOpt.maxtdiff);
	RejectThres  ->Text     =s.sprintf("%.1f",PrcOpt.maxinno);
	SlipThres	 ->Text     =s.sprintf("%.3f",PrcOpt.thresslip);
	NumIter		 ->Text     =s.sprintf("%d",  PrcOpt.niter);
	CodeSmooth	 ->Text     =s.sprintf("%d",  PrcOpt.codesmooth);
	ExSatsE		 ->Text     =ExSats;
	
	SolFormat	 ->ItemIndex=SolOpt.posf;
	TimeFormat	 ->ItemIndex=SolOpt.timef==0?0:SolOpt.times+1;
	LatLonFormat ->ItemIndex=SolOpt.degf;
	FieldSep	 ->Text     =SolOpt.sep;
	OutputHead	 ->ItemIndex=SolOpt.outhead;
	OutputOpt	 ->ItemIndex=SolOpt.outopt;
	OutputDatum  ->ItemIndex=SolOpt.datum;
	OutputHeight ->ItemIndex=SolOpt.height;
	OutputGeoid  ->ItemIndex=SolOpt.geoid;
	DebugTrace	 ->ItemIndex=DebugTraceF;
	
	MeasErr1	 ->Text     =s.sprintf("%.1f",PrcOpt.err[0]);
	MeasErr2	 ->Text     =s.sprintf("%.3f",PrcOpt.err[1]);
	MeasErr3	 ->Text     =s.sprintf("%.3f",PrcOpt.err[2]);
	MeasErr4	 ->Text     =s.sprintf("%.3f",PrcOpt.err[3]);
	PrNoise1	 ->Text     =s.sprintf("%.2E",PrcOpt.prn[0]);
	PrNoise2	 ->Text     =s.sprintf("%.2E",PrcOpt.prn[1]);
	PrNoise3	 ->Text     =s.sprintf("%.2E",PrcOpt.prn[2]);
	SatClkStab	 ->Text     =s.sprintf("%.2E",PrcOpt.sclkstab);
	
	RovPosType	 ->ItemIndex=RovPosTypeF;
	RefPosType	 ->ItemIndex=RefPosTypeF;
	RovAntPcv	 ->Checked  =RovAntPcvF;
	RefAntPcv	 ->Checked  =RefAntPcvF;
	RovAnt		 ->Text     =RovAntF;
	RefAnt		 ->Text     =RefAntF;
	RovAntE		 ->Text     =s.sprintf("%.3f",RovAntDel[0]);
	RovAntN		 ->Text     =s.sprintf("%.3f",RovAntDel[1]);
	RovAntU		 ->Text     =s.sprintf("%.3f",RovAntDel[2]);
	RefAntE		 ->Text     =s.sprintf("%.3f",RefAntDel[0]);
	RefAntN		 ->Text     =s.sprintf("%.3f",RefAntDel[1]);
	RefAntU		 ->Text     =s.sprintf("%.3f",RefAntDel[2]);
	SetPos(RovPosType->ItemIndex,editu,RovPos);
	SetPos(RefPosType->ItemIndex,editr,RefPos);
	
	AntPcvFile	 ->Text     =AntPcvFileF;
	StaPosFile	 ->Text     =StaPosFileF;
	GoogleEarthFile->Text   =GoogleEarthFileF;
	ReadAntList();
	
	SvrCycleE	 ->Text     =s.sprintf("%d",SvrCycle);
	TimeoutTimeE ->Text     =s.sprintf("%d",TimeoutTime);
	ReconTimeE   ->Text     =s.sprintf("%d",ReconTime);
	NmeaCycleE   ->Text     =s.sprintf("%d",NmeaCycle);
	SvrBuffSizeE ->Text     =s.sprintf("%d",SvrBuffSize);
	SolBuffSizeE ->Text     =s.sprintf("%d",SolBuffSize);
	SavedSolE    ->Text     =s.sprintf("%d",SavedSol);
	NavSelectS   ->ItemIndex=NavSelect;
	SbasSatE     ->Text     =s.sprintf("%d",SbasSat);
	DgpsCorrL    ->ItemIndex=DgpsCorr;
	SbasCorr1    ->Checked  =SbasCorr&SBSOPT_LCORR;
	SbasCorr2    ->Checked  =SbasCorr&SBSOPT_ICORR;
	SbasCorr3    ->Checked  =SbasCorr&SBSOPT_FCORR;
	SbasCorr4    ->Checked  =SbasCorr&SBSOPT_RANGE;
	SolBuffSizeE ->Text     =s.sprintf("%d",SolBuffSize);
	
	FontLabel->Font->Assign(PosFont);
	FontLabel->Caption=FontLabel->Font->Name+s.sprintf(" %dpt",FontLabel->Font->Size);
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SetOpt(void)
{
	TEdit *editu[]={RovPos1,RovPos2,RovPos3};
	TEdit *editr[]={RefPos1,RefPos2,RefPos3};
	
	PrcOpt.mode      =PosMode     ->ItemIndex;
	PrcOpt.nf        =Freq        ->ItemIndex+1;
	PrcOpt.elmin     =ElMask      ->Text.ToDouble()*D2R;
	PrcOpt.snrmin    =SnrMask     ->Text.ToDouble();
	PrcOpt.estiono   =IonoEst     ->ItemIndex;
	PrcOpt.esttrop   =TropEst     ->ItemIndex;
	PrcOpt.modear    =AmbRes      ->ItemIndex;
	PrcOpt.thresar   =ValidThresAR->Text.ToDouble();
	PrcOpt.maxout    =OutCntResetBias->Text.ToInt();
	PrcOpt.minlock   =LockCntFixAmb->Text.ToInt();
	PrcOpt.elmaskar  =ElMaskAR    ->Text.ToDouble()*D2R;
	PrcOpt.maxtdiff  =MaxAgeDiff  ->Text.ToDouble();
	PrcOpt.maxinno   =RejectThres ->Text.ToDouble();
	PrcOpt.thresslip =SlipThres   ->Text.ToDouble();
	PrcOpt.niter     =NumIter     ->Text.ToInt();
	PrcOpt.codesmooth=CodeSmooth  ->Text.ToInt();
	ExSats			 =ExSatsE	  ->Text;
	
	SolOpt.posf      =SolFormat   ->ItemIndex;
	SolOpt.timef     =TimeFormat->ItemIndex==0?0:1;
	SolOpt.times     =TimeFormat->ItemIndex==0?0:TimeFormat->ItemIndex-1;
	SolOpt.degf      =LatLonFormat->ItemIndex;
	strcpy(SolOpt.sep,FieldSep->Text.c_str());
	SolOpt.outhead   =OutputHead  ->ItemIndex;
	SolOpt.outopt    =OutputOpt   ->ItemIndex;
	SolOpt.datum     =OutputDatum ->ItemIndex;
	SolOpt.height    =OutputHeight->ItemIndex;
	SolOpt.geoid     =OutputGeoid ->ItemIndex;
	DebugTraceF      =DebugTrace  ->ItemIndex;
	
	PrcOpt.err[0]    =MeasErr1    ->Text.ToDouble();
	PrcOpt.err[1]    =MeasErr2    ->Text.ToDouble();
	PrcOpt.err[2]    =MeasErr3    ->Text.ToDouble();
	PrcOpt.err[3]    =MeasErr4    ->Text.ToDouble();
	PrcOpt.prn[0]    =PrNoise1    ->Text.ToDouble();
	PrcOpt.prn[1]    =PrNoise2    ->Text.ToDouble();
	PrcOpt.prn[2]    =PrNoise3    ->Text.ToDouble();
	PrcOpt.sclkstab  =SatClkStab  ->Text.ToDouble();
	
	RovPosTypeF      =RovPosType  ->ItemIndex;
	RefPosTypeF      =RefPosType  ->ItemIndex;
	RovAntPcvF       =RovAntPcv   ->Checked;
	RefAntPcvF       =RefAntPcv   ->Checked;
	RovAntF          =RovAnt      ->Text;
	RefAntF          =RefAnt      ->Text;
	RovAntDel[0]     =RovAntE     ->Text.ToDouble();
	RovAntDel[1]     =RovAntN     ->Text.ToDouble();
	RovAntDel[2]     =RovAntU     ->Text.ToDouble();
	RefAntDel[0]     =RefAntE     ->Text.ToDouble();
	RefAntDel[1]     =RefAntN     ->Text.ToDouble();
	RefAntDel[2]     =RefAntU     ->Text.ToDouble();
	GetPos(RovPosType->ItemIndex,editu,RovPos);
	GetPos(RefPosType->ItemIndex,editr,RefPos);
	
	AntPcvFileF      =AntPcvFile  ->Text;
	StaPosFileF      =StaPosFile  ->Text;
	GoogleEarthFileF =GoogleEarthFile->Text;
	
	SvrCycle	     =SvrCycleE   ->Text.ToInt();
	TimeoutTime      =TimeoutTimeE->Text.ToInt();
	ReconTime        =ReconTimeE  ->Text.ToInt();
	NmeaCycle	     =NmeaCycleE  ->Text.ToInt();
	SvrBuffSize      =SvrBuffSizeE->Text.ToInt();
	SolBuffSize      =SolBuffSizeE->Text.ToInt();
	SavedSol         =SavedSolE   ->Text.ToInt();
	NavSelect        =NavSelectS  ->ItemIndex;
	SbasSat          =SbasSatE    ->Text.ToInt();
	DgpsCorr         =DgpsCorrL   ->ItemIndex;
	SbasCorr         =(SbasCorr1->Checked?SBSOPT_LCORR:0)+
				      (SbasCorr2->Checked?SBSOPT_ICORR:0)+
				      (SbasCorr3->Checked?SBSOPT_FCORR:0)+
				      (SbasCorr4->Checked?SBSOPT_RANGE:0);
	PosFont->Assign(FontLabel->Font);
	UpdateEnable();
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::UpdateEnable(void)
{
	Freq           ->Enabled=PosMode->ItemIndex>=1;
	IonoEst        ->Enabled=PosMode->ItemIndex>=1&&Freq->ItemIndex>=1;
	TropEst        ->Enabled=PosMode->ItemIndex>=1;
	
	AmbRes         ->Enabled=PosMode->ItemIndex>=2;
	ValidThresAR   ->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	LockCntFixAmb  ->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	ElMaskAR       ->Enabled=PosMode->ItemIndex>=2&&AmbRes->ItemIndex>=1;
	OutCntResetBias->Enabled=PosMode->ItemIndex>=2;
	SlipThres      ->Enabled=PosMode->ItemIndex>=2;
	MaxAgeDiff     ->Enabled=PosMode->ItemIndex>=1;
	RejectThres    ->Enabled=PosMode->ItemIndex>=1;
	NumIter        ->Enabled=PosMode->ItemIndex>=1;
	
	OutputHead     ->Enabled=SolFormat->ItemIndex!=3;
//	OutputOpt      ->Enabled=SolFormat->ItemIndex!=3;
	TimeFormat     ->Enabled=SolFormat->ItemIndex!=3;
	LatLonFormat   ->Enabled=SolFormat->ItemIndex==0;
	FieldSep       ->Enabled=SolFormat->ItemIndex!=3;
	OutputDatum    ->Enabled=SolFormat->ItemIndex==0;
	OutputHeight   ->Enabled=SolFormat->ItemIndex==0;
	OutputGeoid    ->Enabled=SolFormat->ItemIndex==0&&OutputHeight->ItemIndex==1;
	
	RefAnt         ->Enabled=RefAntPcv->Checked;
	RefAntE        ->Enabled=RefAntPcv->Checked;
	RefAntN        ->Enabled=RefAntPcv->Checked;
	RefAntU        ->Enabled=RefAntPcv->Checked;
	RovAnt         ->Enabled=RovAntPcv->Checked;
	RovAntE        ->Enabled=RovAntPcv->Checked;
	RovAntN        ->Enabled=RovAntPcv->Checked;
	RovAntU        ->Enabled=RovAntPcv->Checked;
	RovPosType     ->Enabled=PosMode->ItemIndex==5;
	RovPos1        ->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	RovPos2        ->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	RovPos3        ->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	BtnRovPos      ->Enabled=PosMode->ItemIndex==5&&RovPosType->ItemIndex<=2;
	RefPosType     ->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex<4;
	RefPos1        ->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex<4&&RefPosType->ItemIndex<=2;
	RefPos2        ->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex<4&&RefPosType->ItemIndex<=2;
	RefPos3        ->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex<4&&RefPosType->ItemIndex<=2;
	BtnRefPos      ->Enabled=0<PosMode->ItemIndex&&PosMode->ItemIndex<4&&RefPosType->ItemIndex<=2;
	
	SbasSatE       ->Enabled=DgpsCorrL->ItemIndex==1;
	SbasCorr1      ->Enabled=DgpsCorrL->ItemIndex==1;
	SbasCorr2      ->Enabled=DgpsCorrL->ItemIndex==1;
	SbasCorr3      ->Enabled=DgpsCorrL->ItemIndex==1;
	SbasCorr4      ->Enabled=DgpsCorrL->ItemIndex==1;
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::GetPos(int type, TEdit **edit, double *pos)
{
	double p[3]={0},dms1[3]={0},dms2[3]={0};
	
	if (type==1) { /* lat/lon/height dms/m */
		sscanf(edit[0]->Text.c_str(),"%lf %lf %lf",dms1,dms1+1,dms1+2);
		sscanf(edit[1]->Text.c_str(),"%lf %lf %lf",dms2,dms2+1,dms2+2);
		p[0]=(dms1[0]<0?-1:1)*(fabs(dms1[0])+dms1[1]/60+dms1[2]/3600)*D2R;
		p[1]=(dms1[0]<0?-1:1)*(fabs(dms2[0])+dms2[1]/60+dms2[2]/3600)*D2R;
		p[2]=edit[2]->Text.ToDouble();
		pos2ecef(p,pos);
	}
	else if (type==2) { /* x/y/z-ecef */
		pos[0]=edit[0]->Text.ToDouble();
		pos[1]=edit[1]->Text.ToDouble();
		pos[2]=edit[2]->Text.ToDouble();
	}
	else {
		p[0]=edit[0]->Text.ToDouble()*D2R;
		p[1]=edit[1]->Text.ToDouble()*D2R;
		p[2]=edit[2]->Text.ToDouble();
		pos2ecef(p,pos);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::SetPos(int type, TEdit **edit, double *pos)
{
	AnsiString s;
	double p[3],dms1[3],dms2[3],s1,s2;
	
	if (type==1) { /* lat/lon/height dms/m */
		ecef2pos(pos,p); s1=p[0]<0?-1:1; s2=p[1]<0?-1:1;
		p[0]=fabs(p[0])*R2D+1E-12; p[1]=fabs(p[1])*R2D+1E-12;
		dms1[0]=floor(p[0]); p[0]=(p[0]-dms1[0])*60.0;
		dms1[1]=floor(p[0]); dms1[2]=(p[0]-dms1[1])*60.0;
		dms2[0]=floor(p[1]); p[1]=(p[1]-dms2[0])*60.0;
		dms2[1]=floor(p[1]); dms2[2]=(p[1]-dms2[1])*60.0;
		edit[0]->Text=s.sprintf("%.0f %02.0f %09.6f",s1*dms1[0],dms1[1],dms1[2]);
		edit[1]->Text=s.sprintf("%.0f %02.0f %09.6f",s2*dms2[0],dms2[1],dms2[2]);
		edit[2]->Text=s.sprintf("%.4f",p[2]);
	}
	else if (type==2) { /* x/y/z-ecef */
		edit[0]->Text=s.sprintf("%.4f",pos[0]);
		edit[1]->Text=s.sprintf("%.4f",pos[1]);
		edit[2]->Text=s.sprintf("%.4f",pos[2]);
	}
	else {
		ecef2pos(pos,p);
		edit[0]->Text=s.sprintf("%.9f",p[0]*R2D);
		edit[1]->Text=s.sprintf("%.9f",p[1]*R2D);
		edit[2]->Text=s.sprintf("%.4f",p[2]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptDialog::ReadAntList(void)
{
	FILE *fp;
	char buff[256]="",ant[256]="",*p,*q,*p0=buff,*p1=buff+40;
	char *tag[]={"ANTENNA ID","MODEL #"};
	TStringList *list=new TStringList;
	int i,n=0;
	list->Add("");
	if (!(fp=fopen(AntPcvFile->Text.c_str(),"r"))) return;
	while (fgets(buff,sizeof(buff),fp)) {
		if (++n==3) {
			for (i=0;i<2;i++) {
				if (!(p=strstr(buff,tag[i]))) continue;
				p0=p; for (p1=p0+strlen(tag[i]);*p1&&*p1==' ';p1++) ;
				p1-=2;
			}
		}
		if (n<12||*buff=='\0'||*buff==' ') continue;
		*p1='\0';
		for (p=p1-1;p0<=p&&*p==' ';p--) *p='\0';
		if (strcmp(p0,ant)) {list->Add(p0); strcpy(ant,p0);}
	}
	fclose(fp);
	RovAnt->Items=list;
	RefAnt->Items=list;
}
//---------------------------------------------------------------------------

